// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	"time"

	v1alpha1 "github.com/aquasecurity/starboard/pkg/apis/aquasecurity/v1alpha1"
	scheme "github.com/aquasecurity/starboard/pkg/generated/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// ClusterComplianceReportsGetter has a method to return a ClusterComplianceReportInterface.
// A group's client should implement this interface.
type ClusterComplianceReportsGetter interface {
	ClusterComplianceReports(namespace string) ClusterComplianceReportInterface
}

// ClusterComplianceReportInterface has methods to work with ClusterComplianceReport resources.
type ClusterComplianceReportInterface interface {
	Create(ctx context.Context, clusterComplianceReport *v1alpha1.ClusterComplianceReport, opts v1.CreateOptions) (*v1alpha1.ClusterComplianceReport, error)
	Update(ctx context.Context, clusterComplianceReport *v1alpha1.ClusterComplianceReport, opts v1.UpdateOptions) (*v1alpha1.ClusterComplianceReport, error)
	UpdateStatus(ctx context.Context, clusterComplianceReport *v1alpha1.ClusterComplianceReport, opts v1.UpdateOptions) (*v1alpha1.ClusterComplianceReport, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.ClusterComplianceReport, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.ClusterComplianceReportList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.ClusterComplianceReport, err error)
	ClusterComplianceReportExpansion
}

// clusterComplianceReports implements ClusterComplianceReportInterface
type clusterComplianceReports struct {
	client rest.Interface
	ns     string
}

// newClusterComplianceReports returns a ClusterComplianceReports
func newClusterComplianceReports(c *AquasecurityV1alpha1Client, namespace string) *clusterComplianceReports {
	return &clusterComplianceReports{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the clusterComplianceReport, and returns the corresponding clusterComplianceReport object, and an error if there is any.
func (c *clusterComplianceReports) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.ClusterComplianceReport, err error) {
	result = &v1alpha1.ClusterComplianceReport{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("clustercompliancereports").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of ClusterComplianceReports that match those selectors.
func (c *clusterComplianceReports) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.ClusterComplianceReportList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.ClusterComplianceReportList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("clustercompliancereports").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested clusterComplianceReports.
func (c *clusterComplianceReports) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("clustercompliancereports").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a clusterComplianceReport and creates it.  Returns the server's representation of the clusterComplianceReport, and an error, if there is any.
func (c *clusterComplianceReports) Create(ctx context.Context, clusterComplianceReport *v1alpha1.ClusterComplianceReport, opts v1.CreateOptions) (result *v1alpha1.ClusterComplianceReport, err error) {
	result = &v1alpha1.ClusterComplianceReport{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("clustercompliancereports").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(clusterComplianceReport).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a clusterComplianceReport and updates it. Returns the server's representation of the clusterComplianceReport, and an error, if there is any.
func (c *clusterComplianceReports) Update(ctx context.Context, clusterComplianceReport *v1alpha1.ClusterComplianceReport, opts v1.UpdateOptions) (result *v1alpha1.ClusterComplianceReport, err error) {
	result = &v1alpha1.ClusterComplianceReport{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("clustercompliancereports").
		Name(clusterComplianceReport.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(clusterComplianceReport).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *clusterComplianceReports) UpdateStatus(ctx context.Context, clusterComplianceReport *v1alpha1.ClusterComplianceReport, opts v1.UpdateOptions) (result *v1alpha1.ClusterComplianceReport, err error) {
	result = &v1alpha1.ClusterComplianceReport{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("clustercompliancereports").
		Name(clusterComplianceReport.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(clusterComplianceReport).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the clusterComplianceReport and deletes it. Returns an error if one occurs.
func (c *clusterComplianceReports) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("clustercompliancereports").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *clusterComplianceReports) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("clustercompliancereports").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched clusterComplianceReport.
func (c *clusterComplianceReports) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.ClusterComplianceReport, err error) {
	result = &v1alpha1.ClusterComplianceReport{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("clustercompliancereports").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
