// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	"time"

	v1alpha1 "github.com/aquasecurity/starboard/pkg/apis/aquasecurity/v1alpha1"
	scheme "github.com/aquasecurity/starboard/pkg/generated/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// ClusterVulnerabilityReportsGetter has a method to return a ClusterVulnerabilityReportInterface.
// A group's client should implement this interface.
type ClusterVulnerabilityReportsGetter interface {
	ClusterVulnerabilityReports() ClusterVulnerabilityReportInterface
}

// ClusterVulnerabilityReportInterface has methods to work with ClusterVulnerabilityReport resources.
type ClusterVulnerabilityReportInterface interface {
	Create(ctx context.Context, clusterVulnerabilityReport *v1alpha1.ClusterVulnerabilityReport, opts v1.CreateOptions) (*v1alpha1.ClusterVulnerabilityReport, error)
	Update(ctx context.Context, clusterVulnerabilityReport *v1alpha1.ClusterVulnerabilityReport, opts v1.UpdateOptions) (*v1alpha1.ClusterVulnerabilityReport, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.ClusterVulnerabilityReport, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.ClusterVulnerabilityReportList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.ClusterVulnerabilityReport, err error)
	ClusterVulnerabilityReportExpansion
}

// clusterVulnerabilityReports implements ClusterVulnerabilityReportInterface
type clusterVulnerabilityReports struct {
	client rest.Interface
}

// newClusterVulnerabilityReports returns a ClusterVulnerabilityReports
func newClusterVulnerabilityReports(c *AquasecurityV1alpha1Client) *clusterVulnerabilityReports {
	return &clusterVulnerabilityReports{
		client: c.RESTClient(),
	}
}

// Get takes name of the clusterVulnerabilityReport, and returns the corresponding clusterVulnerabilityReport object, and an error if there is any.
func (c *clusterVulnerabilityReports) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.ClusterVulnerabilityReport, err error) {
	result = &v1alpha1.ClusterVulnerabilityReport{}
	err = c.client.Get().
		Resource("clustervulnerabilityreports").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of ClusterVulnerabilityReports that match those selectors.
func (c *clusterVulnerabilityReports) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.ClusterVulnerabilityReportList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.ClusterVulnerabilityReportList{}
	err = c.client.Get().
		Resource("clustervulnerabilityreports").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested clusterVulnerabilityReports.
func (c *clusterVulnerabilityReports) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("clustervulnerabilityreports").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a clusterVulnerabilityReport and creates it.  Returns the server's representation of the clusterVulnerabilityReport, and an error, if there is any.
func (c *clusterVulnerabilityReports) Create(ctx context.Context, clusterVulnerabilityReport *v1alpha1.ClusterVulnerabilityReport, opts v1.CreateOptions) (result *v1alpha1.ClusterVulnerabilityReport, err error) {
	result = &v1alpha1.ClusterVulnerabilityReport{}
	err = c.client.Post().
		Resource("clustervulnerabilityreports").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(clusterVulnerabilityReport).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a clusterVulnerabilityReport and updates it. Returns the server's representation of the clusterVulnerabilityReport, and an error, if there is any.
func (c *clusterVulnerabilityReports) Update(ctx context.Context, clusterVulnerabilityReport *v1alpha1.ClusterVulnerabilityReport, opts v1.UpdateOptions) (result *v1alpha1.ClusterVulnerabilityReport, err error) {
	result = &v1alpha1.ClusterVulnerabilityReport{}
	err = c.client.Put().
		Resource("clustervulnerabilityreports").
		Name(clusterVulnerabilityReport.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(clusterVulnerabilityReport).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the clusterVulnerabilityReport and deletes it. Returns an error if one occurs.
func (c *clusterVulnerabilityReports) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Resource("clustervulnerabilityreports").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *clusterVulnerabilityReports) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Resource("clustervulnerabilityreports").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched clusterVulnerabilityReport.
func (c *clusterVulnerabilityReports) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.ClusterVulnerabilityReport, err error) {
	result = &v1alpha1.ClusterVulnerabilityReport{}
	err = c.client.Patch(pt).
		Resource("clustervulnerabilityreports").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
